--- old/usr/src/uts/common/inet/ip/sadb.c	Wed Jul  9 13:48:02 2014
+++ new/usr/src/uts/common/inet/ip/sadb.c	Wed Jul  9 13:48:02 2014
@@ -6635,8 +6901,12 @@
 }
 
 /*
- * For sctp conn_faddr is the primary address, hence this is of limited
- * use for sctp.
+ * Takes ipsec_selector_t (data to form query), ipsec_policy_t (what we need
+ * to populate), and ip_stack_t (contains state data to query) pointers. This is
+ * a generic protocol look-up function to find a relevant connection that can be
+ * converted in a policy.
+ * XXX For sctp conn_faddr is the primary address, hence this is of limited
+ * use for sctp. Do we care, given sctp has its own lookup?
  */
 static void
 ipsec_oth_pol(ipsec_selector_t *sel, ipsec_policy_t **ppp,
@@ -6646,6 +6916,8 @@
 	connf_t		*connfp;
 	conn_t		*connp;
 
+	ASSERT(*ppp == NULL);
+
 	if (isv4) {
 		connfp = &ipst->ips_ipcl_proto_fanout_v4[sel->ips_protocol];
 	} else {
@@ -6684,19 +6956,16 @@
 }
 
 /*
- * Construct an inverse ACQUIRE reply based on:
+ * This code is called from keysock to handle inverse acquire messages.  We
+ * are passed a pointer to sadb_msg_t, a fixed-size array of sadb_ext_t, and a
+ * netstack_t pointer and return a mblk_t pointer, in which we attempt to
+ * construct a return acquire message. In case of errors, we return a NULL
+ * pointer and populate samsg->sadb_msg_errno and samsg->sadb_msg_diagnostic,
+ * which is handled as an error at the keysock layer. Otherwise keysock does a
+ * passup with our message.
+ * Caller performs basic sanity checks such as NULL external addresses and
+ * only one of two inner addrs being NULL. Remaining checks happen here.
  *
- * 1.) Current global policy.
- * 2.) An conn_t match depending on what all was passed in the extv[].
- * 3.) A tunnel's policy head.
- * ...
- * N.) Other stuff TBD (e.g. identities)
- *
- * If there is an error, set sadb_msg_errno and sadb_x_msg_diagnostic
- * in this function so the caller can extract them where appropriately.
- *
- * The SRC address is the local one - just like an outbound ACQUIRE message.
- *
  * XXX MLS: key management supplies a label which we just reflect back up
  * again.  clearly we need to involve the label in the rest of the checks.
  */
@@ -6716,10 +6985,12 @@
 	ipsec_tun_pol_t *itp = NULL;
 	ipsec_policy_t *pp = NULL;
 	ipsec_selector_t sel, isel;
-	mblk_t *retmp = NULL;
+	mblk_t *retmp;
 	ip_stack_t	*ipst = ns->netstack_ip;
+	sadb_msg_t *retmsg;
+	ipsec_action_t *ap;
+	boolean_t tunnel_mode = B_FALSE;
 
-
 	/* Normalize addresses */
 	if (sadb_addrcheck(NULL, (mblk_t *)samsg, (sadb_ext_t *)srcext, 0, ns)
 	    == KS_IN_ADDR_UNKNOWN) {
@@ -6742,12 +7013,12 @@
 	}
 
 	/* Check for tunnel mode and act appropriately */
+	/*
+	 * Note: keysock_inverse_acquire catches unbalanced extensions and
+	 * makes them into keysock_error calls, so ASSERTs here to confirm.
+	 */
 	if (innsrcext != NULL) {
-		if (inndstext == NULL) {
-			err = EINVAL;
-			diagnostic = SADB_X_DIAGNOSTIC_MISSING_INNER_DST;
-			goto bail;
-		}
+		ASSERT(inndstext != NULL);
 		if (sadb_addrcheck(NULL, (mblk_t *)samsg,
 		    (sadb_ext_t *)innsrcext, 0, ns) == KS_IN_ADDR_UNKNOWN) {
 			err = EINVAL;
@@ -6773,19 +7044,17 @@
 			diagnostic = SADB_X_DIAGNOSTIC_BAD_INNER_SRC_AF;
 			goto bail;
 		}
-	} else if (inndstext != NULL) {
-		err = EINVAL;
-		diagnostic = SADB_X_DIAGNOSTIC_MISSING_INNER_SRC;
-		goto bail;
-	}
+		tunnel_mode = B_TRUE;
+	} else
+		ASSERT(inndstext == NULL);
 
-	/* Get selectors first, based on outer addresses */
+	/* Convert address extensions into outer selector */
 	err = ipsec_get_inverse_acquire_sel(&sel, srcext, dstext, &diagnostic);
 	if (err != 0)
 		goto bail;
 
-	/* Check for tunnel mode mismatches. */
-	if (innsrcext != NULL &&
+	/* Sanity-check newfound outer selector for tunnel mode mismatches */
+	if (tunnel_mode &&
 	    ((isrc->sin6_family == AF_INET &&
 	    sel.ips_protocol != IPPROTO_ENCAP && sel.ips_protocol != 0) ||
 	    (isrc->sin6_family == AF_INET6 &&
@@ -6796,9 +7065,11 @@
 
 	/*
 	 * Okay, we have the addresses and other selector information.
-	 * Let's first find a conn...
+	 * If our selector is for a protocol on top of IP, we make protocol-
+	 * specific queries that work through useful state (e.g. connections or
+	 * listeners). If we get something back, a reference to it will already
+	 * be held, and we need to release that reference.
 	 */
-	pp = NULL;
 	switch (sel.ips_protocol) {
 	case IPPROTO_TCP:
 		ipsec_tcp_pol(&sel, &pp, ipst);
@@ -6812,8 +7083,10 @@
 	case IPPROTO_ENCAP:
 	case IPPROTO_IPV6:
 		/*
-		 * Assume sel.ips_remote_addr_* has the right address at
-		 * that exact position.
+		 * These cases are IPv6 in IP or IP in IP. Revert to querying
+		 * SPD for tunnel policy, since there's no higher-level protocol
+		 * or stack state to assist. Assume sel.ips_remote_addr_* has
+		 * right address at exact position.
 		 */
 		itp = itp_get_byaddr((uint32_t *)(&sel.ips_local_addr_v6),
 		    (uint32_t *)(&sel.ips_remote_addr_v6), src->sin6_family,
@@ -6826,6 +7099,7 @@
 			 */
 			bzero(&isel, sizeof (isel));
 			isel.ips_isv4 = (sel.ips_protocol == IPPROTO_ENCAP);
+			/* XXX does this make tunnel_mode true? */
 		} /* Else isel is initialized by ipsec_tun_pol(). */
 		err = ipsec_tun_pol(&isel, &pp, innsrcext, inndstext, itp,
 		    &diagnostic);
@@ -6836,14 +7110,14 @@
 		if (err != 0)
 			goto bail;
 		break;
-	default:
+	default: /* Fall through to generic lookup */
 		ipsec_oth_pol(&sel, &pp, ipst);
 		break;
 	}
 
 	/*
-	 * If we didn't find a matching conn_t or other policy head, take a
-	 * look in the global policy.
+	 * If we didn't find a matching conn_t or other policy head (pp retains
+	 * initial NULL value), attempt to revert to the global policy.
 	 */
 	if (pp == NULL) {
 		pp = ipsec_find_policy(IPSEC_TYPE_OUTBOUND, NULL, &sel, ns);
@@ -6860,19 +7134,43 @@
 	 * message based on that, fix fields where appropriate,
 	 * and return the message.
 	 */
-	retmp = sadb_extended_acquire(&sel, pp, NULL,
-	    (itp != NULL && (itp->itp_flags & ITPF_P_TUNNEL)),
-	    samsg->sadb_msg_seq, samsg->sadb_msg_pid, sens, ns);
-	if (pp != NULL) {
+	ap = pp->ipsp_act;
+	ASSERT(ap != NULL);
+
+	if (ap != NULL)
+		IPACT_REFHOLD(ap);
+
+	retmp = sadb_construct_acqmsg(NULL, &sel, ap, pp, ns, sens, 0,
+	    tunnel_mode, B_TRUE, B_TRUE);
+	if (retmp == NULL)
+		goto nomem_bail;
+
+	retmsg = (sadb_msg_t *)retmp->b_rptr;
+	retmsg->sadb_msg_seq = samsg->sadb_msg_seq;
+	retmsg->sadb_msg_pid = samsg->sadb_msg_pid;
+
+	if (pp != NULL)
 		IPPOL_REFRELE(pp);
-	}
+	if (ap != NULL)
+		IPACT_REFRELE(ap);
+
+	return (retmp);
+
+nomem_bail:
+	if (pp != NULL)
+		IPPOL_REFRELE(pp);
+	if (ap != NULL)
+		IPACT_REFRELE(ap);
 	ASSERT(err == 0 && diagnostic == 0);
-	if (retmp == NULL)
-		err = ENOMEM;
+	err = ENOMEM;
 bail:
 	if (itp != NULL) {
 		ITP_REFRELE(itp, ns);
 	}
+	/*
+	 * Write error info into original message, as we may not have resources
+	 * for a proper reply.
+	 */
 	samsg->sadb_msg_errno = (uint8_t)err;
 	samsg->sadb_x_msg_diagnostic = (uint16_t)diagnostic;
 	return (retmp);
@@ -7190,7 +7488,7 @@
 	int rv;
 	ipsec_stack_t	*ipss = sa->ipsa_netstack->netstack_ipsec;
 
-	ASSERT(MUTEX_HELD(&ipss->ipsec_alg_lock));
+	ASSERT(RW_READ_HELD(&ipss->ipsec_alg_lock));
 	ASSERT(MUTEX_HELD(&sa->ipsa_lock));
 
 	/* get pointers to the algorithm info, context template, and key */
--- old/usr/src/uts/common/inet/ip/spd.c	Wed Jul  9 13:48:03 2014
+++ new/usr/src/uts/common/inet/ip/spd.c	Wed Jul  9 13:48:03 2014
@@ -21,6 +21,7 @@
 /*
  * Copyright 2010 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ * Copyright (c) 2012 Nexenta Systems, Inc. All rights reserved.
  */
 
 /*
@@ -412,7 +413,7 @@
 		mutex_destroy(&(ipss->ipsec_sel_hash[i].hash_lock));
 	}
 
-	mutex_enter(&ipss->ipsec_alg_lock);
+	rw_enter(&ipss->ipsec_alg_lock, RW_WRITER);
 	for (algtype = 0; algtype < IPSEC_NALGTYPES; algtype ++) {
 		int nalgs = ipss->ipsec_nalgs[algtype];
 
@@ -421,8 +422,8 @@
 				ipsec_alg_unreg(algtype, i, ns);
 		}
 	}
-	mutex_exit(&ipss->ipsec_alg_lock);
-	mutex_destroy(&ipss->ipsec_alg_lock);
+	rw_exit(&ipss->ipsec_alg_lock);
+	rw_destroy(&ipss->ipsec_alg_lock);
 
 	ipsid_gc(ns);
 	ipsid_fini(ns);
@@ -654,7 +655,7 @@
 		mutex_init(&(ipss->ipsec_sel_hash[i].hash_lock),
 		    NULL, MUTEX_DEFAULT, NULL);
 
-	mutex_init(&ipss->ipsec_alg_lock, NULL, MUTEX_DEFAULT, NULL);
+	rw_init(&ipss->ipsec_alg_lock, NULL, RW_DEFAULT, NULL);
 	for (i = 0; i < IPSEC_NALGTYPES; i++) {
 		ipss->ipsec_nalgs[i] = 0;
 	}
@@ -717,7 +718,7 @@
 	ASSERT(ai != NULL);
 	ASSERT(algid == ai->alg_id);
 
-	ASSERT(MUTEX_HELD(&ipss->ipsec_alg_lock));
+	ASSERT(RW_WRITE_HELD(&ipss->ipsec_alg_lock));
 
 	holder = algid;
 
@@ -754,7 +755,7 @@
 	ipsec_stack_t	*ipss = ns->netstack_ipsec;
 	int newcount = ipss->ipsec_nalgs[at];
 
-	ASSERT(MUTEX_HELD(&ipss->ipsec_alg_lock));
+	ASSERT(RW_WRITE_HELD(&ipss->ipsec_alg_lock));
 
 	for (i = 0; i <= newcount; i++) {
 		if (copyback) {
@@ -775,7 +776,7 @@
 {
 	ipsec_stack_t	*ipss = ns->netstack_ipsec;
 
-	ASSERT(MUTEX_HELD(&ipss->ipsec_alg_lock));
+	ASSERT(RW_WRITE_HELD(&ipss->ipsec_alg_lock));
 
 	ASSERT(ipss->ipsec_alglists[algtype][alg->alg_id] == NULL);
 	ipsec_alg_fix_min_max(alg, algtype, ns);
@@ -794,7 +795,7 @@
 {
 	ipsec_stack_t	*ipss = ns->netstack_ipsec;
 
-	ASSERT(MUTEX_HELD(&ipss->ipsec_alg_lock));
+	ASSERT(RW_WRITE_HELD(&ipss->ipsec_alg_lock));
 
 	ASSERT(ipss->ipsec_alglists[algtype][algid] != NULL);
 	ipsec_alg_free(ipss->ipsec_alglists[algtype][algid]);
@@ -4687,8 +4688,9 @@
 }
 
 /*
- * Update the minimum and maximum supported key sizes for the
- * specified algorithm. Must be called while holding the algorithms lock.
+ * Update the minimum and maximum supported key sizes for the specified
+ * algorithm, which is either a member of a netstack alg array or about to be,
+ * and therefore must be called holding ipsec_alg_lock for write.
  */
 void
 ipsec_alg_fix_min_max(ipsec_alginfo_t *alg, ipsec_algtype_t alg_type,
@@ -4703,7 +4705,7 @@
 	crypto_mech_usage_t mask;
 	ipsec_stack_t	*ipss = ns->netstack_ipsec;
 
-	ASSERT(MUTEX_HELD(&ipss->ipsec_alg_lock));
+	ASSERT(RW_WRITE_HELD(&ipss->ipsec_alg_lock));
 
 	/*
 	 * Compute the min, max, and default key sizes (in number of
@@ -5056,7 +5058,7 @@
 	 * the algorithm valid flag and trigger an update of the
 	 * SAs that depend on that algorithm.
 	 */
-	mutex_enter(&ipss->ipsec_alg_lock);
+	rw_enter(&ipss->ipsec_alg_lock, RW_WRITER);
 	for (algtype = 0; algtype < IPSEC_NALGTYPES; algtype++) {
 		for (algidx = 0; algidx < ipss->ipsec_nalgs[algtype];
 		    algidx++) {
@@ -5119,7 +5121,7 @@
 				    CRYPTO_MECH_ADDED, ns);
 		}
 	}
-	mutex_exit(&ipss->ipsec_alg_lock);
+	rw_exit(&ipss->ipsec_alg_lock);
 	crypto_free_mech_list(mechs, mech_count);
 
 	if (alg_changed) {
--- old/usr/src/uts/common/inet/ip/spdsock.c	Wed Jul  9 13:48:03 2014
+++ new/usr/src/uts/common/inet/ip/spdsock.c	Wed Jul  9 13:48:03 2014
@@ -20,6 +20,7 @@
  */
 /*
  * Copyright (c) 2001, 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2012 Nexenta Systems, Inc. All rights reserved.
  */
 
 #include <sys/param.h>
@@ -2268,7 +2269,7 @@
 	spdsock_t *ss = (spdsock_t *)q->q_ptr;
 	ipsec_stack_t *ipss = ss->spdsock_spds->spds_netstack->netstack_ipsec;
 
-	mutex_enter(&ipss->ipsec_alg_lock);
+	rw_enter(&ipss->ipsec_alg_lock, RW_READER);
 	/*
 	 * The SPD client expects to receive separate entries for
 	 * AH authentication and ESP authentication supported algorithms.
@@ -2296,7 +2297,7 @@
 
 	m = allocb(size, BPRI_HI);
 	if (m == NULL) {
-		mutex_exit(&ipss->ipsec_alg_lock);
+		rw_exit(&ipss->ipsec_alg_lock);
 		spdsock_error(q, mp, ENOMEM, 0);
 		return;
 	}
@@ -2367,7 +2368,7 @@
 		}
 	}
 
-	mutex_exit(&ipss->ipsec_alg_lock);
+	rw_exit(&ipss->ipsec_alg_lock);
 
 #undef EMITALGATTRS
 #undef EMIT
@@ -2404,7 +2405,7 @@
 	spdsock_t *ss = (spdsock_t *)q->q_ptr;
 	ipsec_stack_t *ipss = ss->spdsock_spds->spds_netstack->netstack_ipsec;
 
-	mutex_enter(&ipss->ipsec_alg_lock);
+	rw_enter(&ipss->ipsec_alg_lock, RW_READER);
 
 	/*
 	 * For each algorithm, we encode:
@@ -2437,7 +2438,7 @@
 
 	m = allocb(size, BPRI_HI);
 	if (m == NULL) {
-		mutex_exit(&ipss->ipsec_alg_lock);
+		rw_exit(&ipss->ipsec_alg_lock);
 		spdsock_error(q, mp, ENOMEM, 0);
 		return;
 	}
@@ -2471,7 +2472,7 @@
 	 */
 	if (act->spd_actions_count == 0) {
 		act->spd_actions_len = 0;
-		mutex_exit(&ipss->ipsec_alg_lock);
+		rw_exit(&ipss->ipsec_alg_lock);
 		goto error;
 	}
 
@@ -2523,7 +2524,7 @@
 		}
 	}
 
-	mutex_exit(&ipss->ipsec_alg_lock);
+	rw_exit(&ipss->ipsec_alg_lock);
 
 #undef EMITALGATTRS
 #undef EMIT
@@ -3684,7 +3685,7 @@
 		}
 	}
 
-	mutex_enter(&ipss->ipsec_alg_lock);
+	rw_enter(&ipss->ipsec_alg_lock, RW_WRITER);
 
 	/*
 	 * For each algorithm currently defined, check if it is
@@ -3740,7 +3741,7 @@
 		    spds->spds_algs_exec_mode[algtype];
 	}
 
-	mutex_exit(&ipss->ipsec_alg_lock);
+	rw_exit(&ipss->ipsec_alg_lock);
 
 	crypto_free_mech_list(mechs, mech_count);
 
--- old/usr/src/uts/common/inet/ipsec_impl.h	Wed Jul  9 13:48:03 2014
+++ new/usr/src/uts/common/inet/ipsec_impl.h	Wed Jul  9 13:48:03 2014
@@ -21,6 +21,7 @@
 /*
  * Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ * Copyright (c) 2012 Nexenta Systems, Inc. All rights reserved.
  */
 
 #ifndef _INET_IPSEC_IMPL_H
@@ -785,7 +786,7 @@
 	 * Because policy needs to know what algorithms are supported, keep the
 	 * lists of algorithms here.
 	 */
-	kmutex_t 		ipsec_alg_lock;
+	krwlock_t 		ipsec_alg_lock;
 
 	uint8_t			ipsec_nalgs[IPSEC_NALGTYPES];
 	ipsec_alginfo_t	*ipsec_alglists[IPSEC_NALGTYPES][IPSEC_MAX_ALGS];
--- old/usr/src/uts/common/inet/ipsecah.h	Wed Jul  9 13:48:03 2014
+++ new/usr/src/uts/common/inet/ipsecah.h	Wed Jul  9 13:48:03 2014
@@ -21,6 +21,7 @@
 /*
  * Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ * Copyright (c) 2012 Nexenta Systems, Inc. All rights reserved.
  */
 
 #ifndef	_INET_IPSECAH_H
@@ -114,6 +115,21 @@
 };
 typedef struct ipsecah_stack ipsecah_stack_t;
 
+#define	ipsecah_debug			ipsecah_params[0].ipsecah_param_value
+#define	ipsecah_age_interval		ipsecah_params[1].ipsecah_param_value
+#define	ipsecah_age_int_max		ipsecah_params[1].ipsecah_param_max
+#define	ipsecah_reap_delay		ipsecah_params[2].ipsecah_param_value
+#define	ipsecah_replay_size		ipsecah_params[3].ipsecah_param_value
+#define	ipsecah_acquire_timeout		ipsecah_params[4].ipsecah_param_value
+#define	ipsecah_larval_timeout		ipsecah_params[5].ipsecah_param_value
+#define	ipsecah_default_soft_bytes	ipsecah_params[6].ipsecah_param_value
+#define	ipsecah_default_hard_bytes	ipsecah_params[7].ipsecah_param_value
+#define	ipsecah_default_soft_addtime	ipsecah_params[8].ipsecah_param_value
+#define	ipsecah_default_hard_addtime	ipsecah_params[9].ipsecah_param_value
+#define	ipsecah_default_soft_usetime	ipsecah_params[10].ipsecah_param_value
+#define	ipsecah_default_hard_usetime	ipsecah_params[11].ipsecah_param_value
+#define	ipsecah_log_unknown_spi		ipsecah_params[12].ipsecah_param_value
+
 #endif	/* _KERNEL */
 
 /*
--- old/usr/src/uts/common/inet/ipsecesp.h	Wed Jul  9 13:48:04 2014
+++ new/usr/src/uts/common/inet/ipsecesp.h	Wed Jul  9 13:48:04 2014
@@ -21,6 +21,7 @@
 /*
  * Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ * Copyright (c) 2012 Nexenta Systems, Inc. All rights reserved.
  */
 
 #ifndef	_INET_IPSECESP_H
@@ -44,6 +45,52 @@
 } ipsecespparam_t;
 
 /*
+ * Stats.  This may eventually become a full-blown SNMP MIB once that spec
+ * stabilizes.
+ */
+
+typedef struct esp_kstats_s {
+	kstat_named_t esp_stat_num_aalgs;
+	kstat_named_t esp_stat_good_auth;
+	kstat_named_t esp_stat_bad_auth;
+	kstat_named_t esp_stat_bad_padding;
+	kstat_named_t esp_stat_replay_failures;
+	kstat_named_t esp_stat_replay_early_failures;
+	kstat_named_t esp_stat_keysock_in;
+	kstat_named_t esp_stat_out_requests;
+	kstat_named_t esp_stat_acquire_requests;
+	kstat_named_t esp_stat_bytes_expired;
+	kstat_named_t esp_stat_out_discards;
+	kstat_named_t esp_stat_crypto_sync;
+	kstat_named_t esp_stat_crypto_async;
+	kstat_named_t esp_stat_crypto_failures;
+	kstat_named_t esp_stat_num_ealgs;
+	kstat_named_t esp_stat_bad_decrypt;
+	kstat_named_t esp_stat_sa_port_renumbers;
+} esp_kstats_t;
+
+/*
+ * espstack->esp_kstats is equal to espstack->esp_ksp->ks_data if
+ * kstat_create_netstack for espstack->esp_ksp succeeds, but when it
+ * fails, it will be NULL. Note this is done for all stack instances,
+ * so it *could* fail. hence a non-NULL checking is done for
+ * ESP_BUMP_STAT and ESP_DEBUMP_STAT
+ */
+#define	ESP_BUMP_STAT(espstack, x)					\
+do {									\
+	if (espstack->esp_kstats != NULL)				\
+		(espstack->esp_kstats->esp_stat_ ## x).value.ui64++;	\
+_NOTE(CONSTCOND)							\
+} while (0)
+
+#define	ESP_DEBUMP_STAT(espstack, x)					\
+do {									\
+	if (espstack->esp_kstats != NULL)				\
+		(espstack->esp_kstats->esp_stat_ ## x).value.ui64--;	\
+_NOTE(CONSTCOND)							\
+} while (0)
+
+/*
  * IPSECESP stack instances
  */
 struct ipsecesp_stack {
@@ -72,7 +119,31 @@
 };
 typedef struct ipsecesp_stack ipsecesp_stack_t;
 
-/* Define *this* NDD variable here because we use it outside ESP proper. */
+#define	ipsecesp_debug	ipsecesp_params[0].ipsecesp_param_value
+#define	ipsecesp_age_interval ipsecesp_params[1].ipsecesp_param_value
+#define	ipsecesp_age_int_max	ipsecesp_params[1].ipsecesp_param_max
+#define	ipsecesp_reap_delay	ipsecesp_params[2].ipsecesp_param_value
+#define	ipsecesp_replay_size	ipsecesp_params[3].ipsecesp_param_value
+#define	ipsecesp_acquire_timeout	\
+	ipsecesp_params[4].ipsecesp_param_value
+#define	ipsecesp_larval_timeout	\
+	ipsecesp_params[5].ipsecesp_param_value
+#define	ipsecesp_default_soft_bytes	\
+	ipsecesp_params[6].ipsecesp_param_value
+#define	ipsecesp_default_hard_bytes	\
+	ipsecesp_params[7].ipsecesp_param_value
+#define	ipsecesp_default_soft_addtime	\
+	ipsecesp_params[8].ipsecesp_param_value
+#define	ipsecesp_default_hard_addtime	\
+	ipsecesp_params[9].ipsecesp_param_value
+#define	ipsecesp_default_soft_usetime	\
+	ipsecesp_params[10].ipsecesp_param_value
+#define	ipsecesp_default_hard_usetime	\
+	ipsecesp_params[11].ipsecesp_param_value
+#define	ipsecesp_log_unknown_spi	\
+	ipsecesp_params[12].ipsecesp_param_value
+#define	ipsecesp_padding_check	\
+	ipsecesp_params[13].ipsecesp_param_value
 #define	ipsecesp_nat_keepalive_interval	\
 	ipsecesp_params[14].ipsecesp_param_value
 
--- old/usr/src/uts/common/inet/sadb.h	Wed Jul  9 13:48:04 2014
+++ new/usr/src/uts/common/inet/sadb.h	Wed Jul  9 13:48:04 2014
@@ -21,6 +21,7 @@
 /*
  * Copyright 2010 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ * Copyright (c) 2012 Nexenta Systems, Inc. All rights reserved.
  */
 
 #ifndef	_INET_SADB_H
@@ -575,7 +576,6 @@
 {
 	uint32_t	s_satype;
 	uint32_t	*s_acquire_timeout;
-	void 		(*s_acqfn)(ipsacq_t *, mblk_t *, netstack_t *);
 	sadb_t		s_v4;
 	sadb_t		s_v6;
 	uint32_t	s_addflags;
@@ -915,9 +915,9 @@
 			ipsec_stack_t *ipss;				\
 									\
 			ipss = assoc->ipsa_netstack->netstack_ipsec;	\
-			mutex_enter(&ipss->ipsec_alg_lock);		\
+			rw_enter(&ipss->ipsec_alg_lock, RW_READER);	\
 			(void) ipsec_create_ctx_tmpl(_sa, _type);	\
-			mutex_exit(&ipss->ipsec_alg_lock);		\
+			rw_exit(&ipss->ipsec_alg_lock);		        \
 		}							\
 		mutex_exit(&assoc->ipsa_lock);				\
 		if ((_tmpl = (_sa)->_which) == IPSEC_CTX_TMPL_ALLOC)	\
